"use strict";
/*
NOTE: this plugin is used to add all the different provider related plugins at once.
This way only one plugin needs to be added to the service in order to get access to the
whole provider implementation.
*/
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var azureProvider_1 = __importDefault(require("./provider/azureProvider"));
var azureInvoke_1 = require("./plugins/invoke/azureInvoke");
var azureLogs_1 = require("./plugins/logs/azureLogs");
var azureRemove_1 = require("./plugins/remove/azureRemove");
var azurePackage_1 = require("./plugins/package/azurePackage");
var azureDeployPlugin_1 = require("./plugins/deploy/azureDeployPlugin");
var loginPlugin_1 = require("./plugins/login/loginPlugin");
var apimServicePlugin_1 = require("./plugins/apim/apimServicePlugin");
var apimFunctionPlugin_1 = require("./plugins/apim/apimFunctionPlugin");
var azureFunc_1 = require("./plugins/func/azureFunc");
var azureOfflinePlugin_1 = require("./plugins/offline/azureOfflinePlugin");
var AzureIndex = /** @class */ (function () {
    function AzureIndex(serverless, options) {
        this.serverless = serverless;
        this.options = options;
        this.serverless.setProvider(azureProvider_1.default.getProviderName(), new azureProvider_1.default(serverless));
        // To be refactored
        this.serverless.pluginManager.addPlugin(azurePackage_1.AzurePackage);
        this.serverless.pluginManager.addPlugin(azureInvoke_1.AzureInvoke);
        this.serverless.pluginManager.addPlugin(azureLogs_1.AzureLogs);
        this.serverless.pluginManager.addPlugin(azureRemove_1.AzureRemove);
        // Refactored
        this.serverless.pluginManager.addPlugin(loginPlugin_1.AzureLoginPlugin);
        this.serverless.pluginManager.addPlugin(azureDeployPlugin_1.AzureDeployPlugin);
        this.serverless.pluginManager.addPlugin(apimServicePlugin_1.AzureApimServicePlugin);
        this.serverless.pluginManager.addPlugin(apimFunctionPlugin_1.AzureApimFunctionPlugin);
        this.serverless.pluginManager.addPlugin(azureFunc_1.AzureFuncPlugin);
        this.serverless.pluginManager.addPlugin(azureOfflinePlugin_1.AzureOfflinePlugin);
    }
    return AzureIndex;
}());
exports.default = AzureIndex;
module.exports = AzureIndex;
