"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = __importDefault(require("./index"));
var mockFactory_1 = require("./test/mockFactory");
var azureInvoke_1 = require("./plugins/invoke/azureInvoke");
var azureLogs_1 = require("./plugins/logs/azureLogs");
var azureRemove_1 = require("./plugins/remove/azureRemove");
var azurePackage_1 = require("./plugins/package/azurePackage");
var azureDeployPlugin_1 = require("./plugins/deploy/azureDeployPlugin");
var loginPlugin_1 = require("./plugins/login/loginPlugin");
var apimServicePlugin_1 = require("./plugins/apim/apimServicePlugin");
var apimFunctionPlugin_1 = require("./plugins/apim/apimFunctionPlugin");
var azureProvider_1 = __importDefault(require("./provider/azureProvider"));
describe("Azure Index", function () {
    it("contains all registered plugins", function () {
        var sls = mockFactory_1.MockFactory.createTestServerless();
        var options = mockFactory_1.MockFactory.createTestServerlessOptions();
        new index_1.default(sls, options);
        sls.setProvider = jest.fn();
        expect(sls.setProvider).toBeCalledWith("azure", new azureProvider_1.default(sls));
        expect(sls.pluginManager.addPlugin).toBeCalledWith(azurePackage_1.AzurePackage);
        expect(sls.pluginManager.addPlugin).toBeCalledWith(azureInvoke_1.AzureInvoke);
        expect(sls.pluginManager.addPlugin).toBeCalledWith(azureLogs_1.AzureLogs);
        expect(sls.pluginManager.addPlugin).toBeCalledWith(azureRemove_1.AzureRemove);
        expect(sls.pluginManager.addPlugin).toBeCalledWith(loginPlugin_1.AzureLoginPlugin);
        expect(sls.pluginManager.addPlugin).toBeCalledWith(azureDeployPlugin_1.AzureDeployPlugin);
        expect(sls.pluginManager.addPlugin).toBeCalledWith(apimServicePlugin_1.AzureApimServicePlugin);
        expect(sls.pluginManager.addPlugin).toBeCalledWith(apimFunctionPlugin_1.AzureApimFunctionPlugin);
    });
});
