"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var mockFactory_1 = require("../../test/mockFactory");
var utils_1 = require("../../test/utils");
var azureDeployPlugin_1 = require("./azureDeployPlugin");
jest.mock("../../services/functionAppService");
var functionAppService_1 = require("../../services/functionAppService");
jest.mock("../../services/resourceService");
var resourceService_1 = require("../../services/resourceService");
describe("Deploy plugin", function () {
    afterEach(function () {
        jest.resetAllMocks();
    });
    it("calls deploy hook", function () { return __awaiter(_this, void 0, void 0, function () {
        var deployResourceGroup, functionAppStub, deploy, uploadFunctions, sls, options, plugin;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    deployResourceGroup = jest.fn();
                    functionAppStub = mockFactory_1.MockFactory.createTestSite();
                    deploy = jest.fn(function () { return Promise.resolve(functionAppStub); });
                    uploadFunctions = jest.fn();
                    resourceService_1.ResourceService.prototype.deployResourceGroup = deployResourceGroup;
                    functionAppService_1.FunctionAppService.prototype.deploy = deploy;
                    functionAppService_1.FunctionAppService.prototype.uploadFunctions = uploadFunctions;
                    sls = mockFactory_1.MockFactory.createTestServerless();
                    options = mockFactory_1.MockFactory.createTestServerlessOptions();
                    plugin = new azureDeployPlugin_1.AzureDeployPlugin(sls, options);
                    return [4 /*yield*/, utils_1.invokeHook(plugin, "deploy:deploy")];
                case 1:
                    _a.sent();
                    expect(deployResourceGroup).toBeCalled();
                    expect(deploy).toBeCalled();
                    expect(uploadFunctions).toBeCalledWith(functionAppStub);
                    return [2 /*return*/];
            }
        });
    }); });
    it("lists deployments", function () { return __awaiter(_this, void 0, void 0, function () {
        var deployments, sls, options, plugin, expectedLogStatement, deployments_1, deployments_1_1, dep;
        var e_1, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    deployments = mockFactory_1.MockFactory.createTestDeployments();
                    resourceService_1.ResourceService.prototype.getDeployments = jest.fn(function () { return Promise.resolve(deployments); });
                    sls = mockFactory_1.MockFactory.createTestServerless();
                    options = mockFactory_1.MockFactory.createTestServerlessOptions();
                    plugin = new azureDeployPlugin_1.AzureDeployPlugin(sls, options);
                    return [4 /*yield*/, utils_1.invokeHook(plugin, "deploy:list:list")];
                case 1:
                    _b.sent();
                    expectedLogStatement = "\n\nDeployments";
                    try {
                        for (deployments_1 = __values(deployments), deployments_1_1 = deployments_1.next(); !deployments_1_1.done; deployments_1_1 = deployments_1.next()) {
                            dep = deployments_1_1.value;
                            expectedLogStatement += "\n-----------\n";
                            expectedLogStatement += "Name: " + dep.name + "\n";
                            expectedLogStatement += "Timestamp: " + dep.properties.timestamp.getTime() + "\n";
                            expectedLogStatement += "Datetime: " + dep.properties.timestamp.toISOString() + "\n";
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (deployments_1_1 && !deployments_1_1.done && (_a = deployments_1.return)) _a.call(deployments_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                    expectedLogStatement += "-----------\n";
                    expect(sls.cli.log).lastCalledWith(expectedLogStatement);
                    return [2 /*return*/];
            }
        });
    }); });
    it("logs empty deployment list", function () { return __awaiter(_this, void 0, void 0, function () {
        var sls, resourceGroup, options, plugin;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sls = mockFactory_1.MockFactory.createTestServerless();
                    resourceGroup = "rg1";
                    resourceService_1.ResourceService.prototype.getDeployments = jest.fn(function () { return Promise.resolve([]); });
                    resourceService_1.ResourceService.prototype.getResourceGroupName = jest.fn(function () { return resourceGroup; });
                    options = mockFactory_1.MockFactory.createTestServerlessOptions();
                    plugin = new azureDeployPlugin_1.AzureDeployPlugin(sls, options);
                    return [4 /*yield*/, utils_1.invokeHook(plugin, "deploy:list:list")];
                case 1:
                    _a.sent();
                    expect(sls.cli.log).lastCalledWith("No deployments found for resource group '" + resourceGroup + "'");
                    return [2 /*return*/];
            }
        });
    }); });
});
