import Serverless from "serverless";
import { ServerlessAzureConfig } from "../models/serverless";
export declare abstract class BaseService {
    protected serverless: Serverless;
    protected options: Serverless.Options;
    protected baseUrl: string;
    protected serviceName: string;
    protected credentials: any;
    protected subscriptionId: string;
    protected resourceGroup: string;
    protected deploymentName: string;
    protected deploymentContainerName: string;
    protected storageAccountName: string;
    protected config: ServerlessAzureConfig;
    protected constructor(serverless: Serverless, options?: Serverless.Options, authenticate?: boolean);
    getRegion(): string;
    getStage(): string;
    getResourceGroupName(): string;
    /**
     * Sends an API request using axios HTTP library
     * @param method The HTTP method
     * @param relativeUrl The relative url
     * @param options Additional HTTP options including headers, etc
     */
    protected sendApiRequest(method: string, relativeUrl: string, options?: any): Promise<import("axios").AxiosResponse<any>>;
    /**
     * Uploads the specified file via HTTP request
     * @param requestOptions The HTTP request options
     * @param filePath The local file path
     */
    protected sendFile(requestOptions: any, filePath: any): Promise<unknown>;
    protected log(message: string): void;
    protected slsFunctions(): any;
    protected slsConfigFile(): string;
    private setDefaultValues;
}
