"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
jest.mock("axios", function () { return jest.fn(); });
var axios_1 = __importDefault(require("axios"));
var mock_fs_1 = __importDefault(require("mock-fs"));
var mockFactory_1 = require("../test/mockFactory");
jest.mock("request", function () { return mockFactory_1.MockFactory.createTestMockRequestFactory(); });
var request_1 = __importDefault(require("request"));
var fs_1 = __importDefault(require("fs"));
var baseService_1 = require("./baseService");
var MockService = /** @class */ (function (_super) {
    __extends(MockService, _super);
    function MockService(serverless, options) {
        return _super.call(this, serverless, options) || this;
    }
    MockService.prototype.axiosRequest = function (method, url, options) {
        return this.sendApiRequest(method, url, options);
    };
    MockService.prototype.postFile = function (requestOptions, filePath) {
        return this.sendFile(requestOptions, filePath);
    };
    MockService.prototype.getProperties = function () {
        return {
            baseUrl: this.baseUrl,
            serviceName: this.serviceName,
            credentials: this.credentials,
            subscriptionId: this.subscriptionId,
            resourceGroup: this.resourceGroup,
            deploymentName: this.deploymentName,
        };
    };
    return MockService;
}(baseService_1.BaseService));
describe("Base Service", function () {
    var service;
    var sls;
    var slsConfig = {
        service: "My custom service",
        provider: {
            resourceGroup: "My-Resource-Group",
            deploymentName: "My-Deployment",
        },
    };
    afterAll(function () {
        mock_fs_1.default.restore();
    });
    function createMockService(options) {
        sls = mockFactory_1.MockFactory.createTestServerless();
        sls.variables["azureCredentials"] = mockFactory_1.MockFactory.createTestAzureCredentials();
        sls.variables["subscriptionId"] = "ABC123";
        Object.assign(sls.service, slsConfig);
        return new MockService(sls, options);
    }
    beforeEach(function () {
        service = createMockService();
    });
    it("Initializes common service properties", function () {
        var props = service.getProperties();
        expect(props.baseUrl).toEqual("https://management.azure.com");
        expect(props.credentials).toEqual(sls.variables["azureCredentials"]);
        expect(props.subscriptionId).toEqual(sls.variables["subscriptionId"]);
        expect(props.serviceName).toEqual(slsConfig.service);
        expect(props.resourceGroup).toEqual(slsConfig.provider.resourceGroup);
        expect(props.deploymentName).toEqual(slsConfig.provider.deploymentName);
    });
    it("Sets default region and stage values if not defined", function () {
        var mockService = new MockService(sls);
        expect(mockService).not.toBeNull();
        expect(sls.service.provider.region).toEqual("westus");
        expect(sls.service.provider.stage).toEqual("dev");
    });
    it("returns region and stage based on CLI options", function () {
        var cliOptions = {
            stage: "prod",
            region: "eastus2"
        };
        var mockService = new MockService(sls, cliOptions);
        expect(mockService.getRegion()).toEqual(cliOptions.region);
        expect(mockService.getStage()).toEqual(cliOptions.stage);
    });
    it("Sets default region and stage values if not defined", function () {
        var mockService = new MockService(sls);
        expect(mockService).not.toBeNull();
        expect(sls.service.provider.region).toEqual("westus");
        expect(sls.service.provider.stage).toEqual("dev");
    });
    it("returns region and stage based on CLI options", function () {
        var cliOptions = {
            stage: "prod",
            region: "eastus2"
        };
        var mockService = new MockService(sls, cliOptions);
        expect(mockService.getRegion()).toEqual(cliOptions.region);
        expect(mockService.getStage()).toEqual(cliOptions.stage);
    });
    it("Generates resource group name from sls yaml config", function () {
        var mockService = new MockService(sls);
        var resourceGroupName = mockService.getResourceGroupName();
        expect(resourceGroupName).toEqual(sls.service.provider["resourceGroup"]);
    });
    it("Generates resource group from convention when NOT defined in sls yaml", function () {
        sls.service.provider["resourceGroup"] = null;
        var mockService = new MockService(sls);
        var resourceGroupName = mockService.getResourceGroupName();
        var region = mockService.getRegion();
        var stage = mockService.getStage();
        expect(resourceGroupName).toEqual("sls-" + region + "-" + stage + "-" + sls.service["service"] + "-rg");
    });
    it("Fails if credentials have not been set in serverless config", function () {
        sls.variables["azureCredentials"] = null;
        expect(function () { return new MockService(sls); }).toThrow();
    });
    it("Makes HTTP request via axios", function () { return __awaiter(_this, void 0, void 0, function () {
        var method, url, axiosMock, options, expectedHeaders;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    method = "GET";
                    url = "https://api.service.com/foo/bar";
                    axiosMock = axios_1.default;
                    options = {
                        headers: {
                            "x-custom": "value",
                        }
                    };
                    return [4 /*yield*/, service.axiosRequest(method, url, options)];
                case 1:
                    _a.sent();
                    expectedHeaders = __assign({}, options.headers, { Authorization: expect.any(String) });
                    expect(axiosMock).toBeCalledWith(url, {
                        method: method,
                        headers: expectedHeaders,
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it("POST a file to a HTTP endpoint", function () { return __awaiter(_this, void 0, void 0, function () {
        var readStreamSpy, filePath, requestOptions;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    mock_fs_1.default({
                        ".serverless": {
                            "project.zip": "contents",
                        },
                    });
                    readStreamSpy = jest.spyOn(fs_1.default, "createReadStream");
                    filePath = ".serverless/project.zip";
                    requestOptions = {
                        method: "POST",
                        uri: "https://myCustomSite.scm.azurewebsites.net/api/zipdeploy/",
                        json: true,
                        headers: {
                            Authorization: "Bearer ABC123",
                            Accept: "*/*",
                            ContentType: "application/octet-stream",
                        }
                    };
                    return [4 /*yield*/, service.postFile(requestOptions, filePath)];
                case 1:
                    _a.sent();
                    expect(readStreamSpy).toBeCalledWith(filePath);
                    expect(request_1.default).toBeCalledWith(requestOptions, expect.anything());
                    readStreamSpy.mockRestore();
                    return [2 /*return*/];
            }
        });
    }); });
});
