"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var arm_appservice_1 = require("@azure/arm-appservice");
var baseService_1 = require("./baseService");
var guard_1 = require("../shared/guard");
var armService_1 = require("./armService");
var functionApp_1 = require("../armTemplates/resources/functionApp");
var FunctionAppService = /** @class */ (function (_super) {
    __extends(FunctionAppService, _super);
    function FunctionAppService(serverless, options) {
        var _this = _super.call(this, serverless, options) || this;
        _this.webClient = new arm_appservice_1.WebSiteManagementClient(_this.credentials, _this.subscriptionId);
        return _this;
    }
    FunctionAppService.prototype.get = function () {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.webClient.webApps.get(this.resourceGroup, functionApp_1.FunctionAppResource.getResourceName(this.config))];
                    case 1:
                        response = _a.sent();
                        if (response.error && (response.error.code === "ResourceNotFound" || response.error.code === "ResourceGroupNotFound")) {
                            return [2 /*return*/, null];
                        }
                        return [2 /*return*/, response];
                }
            });
        });
    };
    FunctionAppService.prototype.getMasterKey = function (functionApp) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, adminToken, keyUrl, response;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = functionApp;
                        if (_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.get()];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        functionApp = _a;
                        return [4 /*yield*/, this.getAuthKey(functionApp)];
                    case 3:
                        adminToken = _b.sent();
                        keyUrl = "https://" + functionApp.defaultHostName + "/admin/host/systemkeys/_master";
                        return [4 /*yield*/, this.sendApiRequest("GET", keyUrl, {
                                json: true,
                                headers: {
                                    "Authorization": "Bearer " + adminToken
                                }
                            })];
                    case 4:
                        response = _b.sent();
                        return [2 /*return*/, response.data.value];
                }
            });
        });
    };
    FunctionAppService.prototype.deleteFunction = function (functionApp, functionName) {
        return __awaiter(this, void 0, void 0, function () {
            var deleteFunctionUrl;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        guard_1.Guard.null(functionApp);
                        guard_1.Guard.empty(functionName);
                        this.serverless.cli.log("-> Deleting function: " + functionName);
                        deleteFunctionUrl = "" + this.baseUrl + functionApp.id + "/functions/" + functionName + "?api-version=2016-08-01";
                        return [4 /*yield*/, this.sendApiRequest("DELETE", deleteFunctionUrl)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    FunctionAppService.prototype.syncTriggers = function (functionApp) {
        return __awaiter(this, void 0, void 0, function () {
            var syncTriggersUrl;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        guard_1.Guard.null(functionApp);
                        this.serverless.cli.log("Syncing function triggers");
                        syncTriggersUrl = "" + this.baseUrl + functionApp.id + "/syncfunctiontriggers?api-version=2016-08-01";
                        return [4 /*yield*/, this.sendApiRequest("POST", syncTriggersUrl)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    FunctionAppService.prototype.cleanUp = function (functionApp) {
        return __awaiter(this, void 0, void 0, function () {
            var deleteTasks, serviceFunctions, deployedFunctions;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        guard_1.Guard.null(functionApp);
                        this.serverless.cli.log("Cleaning up existing functions");
                        deleteTasks = [];
                        serviceFunctions = this.serverless.service.getAllFunctions();
                        return [4 /*yield*/, this.listFunctions(functionApp)];
                    case 1:
                        deployedFunctions = _a.sent();
                        deployedFunctions.forEach(function (func) {
                            if (serviceFunctions.includes(func.name)) {
                                deleteTasks.push(_this.deleteFunction(functionApp, func.name));
                            }
                        });
                        return [4 /*yield*/, Promise.all(deleteTasks)];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    FunctionAppService.prototype.listFunctions = function (functionApp) {
        return __awaiter(this, void 0, void 0, function () {
            var getTokenUrl, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        guard_1.Guard.null(functionApp);
                        getTokenUrl = "" + this.baseUrl + functionApp.id + "/functions?api-version=2016-08-01";
                        return [4 /*yield*/, this.sendApiRequest("GET", getTokenUrl)];
                    case 1:
                        response = _a.sent();
                        if (response.status !== 200) {
                            return [2 /*return*/, []];
                        }
                        return [2 /*return*/, response.data.value.map(function (functionConfig) { return functionConfig.properties; })];
                }
            });
        });
    };
    FunctionAppService.prototype.getFunction = function (functionApp, functionName) {
        return __awaiter(this, void 0, void 0, function () {
            var getFunctionUrl, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        guard_1.Guard.null(functionApp);
                        guard_1.Guard.empty(functionName);
                        getFunctionUrl = "" + this.baseUrl + functionApp.id + "/functions/" + functionName + "?api-version=2016-08-01";
                        return [4 /*yield*/, this.sendApiRequest("GET", getFunctionUrl)];
                    case 1:
                        response = _a.sent();
                        if (response.status !== 200) {
                            return [2 /*return*/, null];
                        }
                        return [2 /*return*/, response.data.properties];
                }
            });
        });
    };
    FunctionAppService.prototype.uploadFunctions = function (functionApp) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        guard_1.Guard.null(functionApp, "functionApp");
                        this.log("Deploying serverless functions...");
                        return [4 /*yield*/, this.zipDeploy(functionApp)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * create all necessary resources as defined in src/provider/armTemplates
     *    resource-group, storage account, app service plan, and app service at the minimum
     */
    FunctionAppService.prototype.deploy = function () {
        return __awaiter(this, void 0, void 0, function () {
            var armService, deployment, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.log("Creating function app: " + this.serviceName);
                        armService = new armService_1.ArmService(this.serverless);
                        if (!this.config.provider.armTemplate) return [3 /*break*/, 2];
                        return [4 /*yield*/, armService.createDeploymentFromConfig(this.config.provider.armTemplate)];
                    case 1:
                        _a = _b.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, armService.createDeploymentFromType(this.config.provider.type || "consumption")];
                    case 3:
                        _a = _b.sent();
                        _b.label = 4;
                    case 4:
                        deployment = _a;
                        return [4 /*yield*/, armService.deployTemplate(deployment)];
                    case 5:
                        _b.sent();
                        return [4 /*yield*/, this.get()];
                    case 6: 
                    // Return function app 
                    return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    FunctionAppService.prototype.zipDeploy = function (functionApp) {
        return __awaiter(this, void 0, void 0, function () {
            var functionAppName, scmDomain, functionZipFile, requestOptions, serverlessFunctions, deployedFunctions;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        functionAppName = functionApp.name;
                        scmDomain = this.getScmDomain(functionApp);
                        this.serverless.cli.log("Deploying zip file to function app: " + functionAppName);
                        functionZipFile = this.serverless.service["artifact"];
                        if (!functionZipFile) {
                            functionZipFile = path_1.default.join(this.serverless.config.servicePath, ".serverless", this.serverless.service.getServiceName() + ".zip");
                        }
                        if (!(functionZipFile && fs_1.default.existsSync(functionZipFile))) {
                            throw new Error("No zip file found for function app");
                        }
                        this.serverless.cli.log("-> Deploying service package @ " + functionZipFile);
                        requestOptions = {
                            method: "POST",
                            uri: "https://" + scmDomain + "/api/zipdeploy/",
                            json: true,
                            headers: {
                                Authorization: "Bearer " + this.credentials.tokenCache._entries[0].accessToken,
                                Accept: "*/*",
                                ContentType: "application/octet-stream",
                            }
                        };
                        return [4 /*yield*/, this.sendFile(requestOptions, functionZipFile)];
                    case 1:
                        _a.sent();
                        this.serverless.cli.log("-> Function package uploaded successfully");
                        serverlessFunctions = this.serverless.service.getAllFunctions();
                        return [4 /*yield*/, this.listFunctions(functionApp)];
                    case 2:
                        deployedFunctions = _a.sent();
                        this.serverless.cli.log("Deployed serverless functions:");
                        deployedFunctions.forEach(function (functionConfig) {
                            // List functions that are part of the serverless yaml config
                            if (serverlessFunctions.includes(functionConfig.name)) {
                                var httpConfig = _this.getFunctionHttpTriggerConfig(functionApp, functionConfig);
                                if (httpConfig) {
                                    var method = httpConfig.methods[0].toUpperCase();
                                    _this.serverless.cli.log("-> " + functionConfig.name + ": " + method + " " + httpConfig.url);
                                }
                            }
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    FunctionAppService.prototype.getFunctionHttpTriggerConfig = function (functionApp, functionConfig) {
        var httpTrigger = functionConfig.config.bindings.find(function (binding) {
            return binding.type === "httpTrigger";
        });
        if (!httpTrigger) {
            return;
        }
        var route = httpTrigger.route || functionConfig.name;
        var url = functionApp.defaultHostName + "/api/" + route;
        return {
            authLevel: httpTrigger.authLevel,
            methods: httpTrigger.methods || ["*"],
            url: url,
            route: httpTrigger.route,
            name: functionConfig.name,
        };
    };
    FunctionAppService.prototype.runKuduCommand = function (functionApp, command) {
        return __awaiter(this, void 0, void 0, function () {
            var scmDomain, requestUrl, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.serverless.cli.log("-> Running Kudu command " + command + "...");
                        scmDomain = this.getScmDomain(functionApp);
                        requestUrl = "https://" + scmDomain + "/api/command";
                        return [4 /*yield*/, this.sendApiRequest("POST", requestUrl, {
                                data: {
                                    command: command,
                                    dir: "site\\wwwroot"
                                }
                            })];
                    case 1:
                        response = _a.sent();
                        if (response.status !== 200) {
                            if (response.data && response.data.Error) {
                                throw new Error(response.data.Error);
                            }
                            throw new Error("Error executing " + command + " command, try again later.");
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Gets a short lived admin token used to retrieve function keys
     */
    FunctionAppService.prototype.getAuthKey = function (functionApp) {
        return __awaiter(this, void 0, void 0, function () {
            var adminTokenUrl, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        adminTokenUrl = "" + this.baseUrl + functionApp.id + "/functions/admin/token?api-version=2016-08-01";
                        return [4 /*yield*/, this.sendApiRequest("GET", adminTokenUrl)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data.replace(/"/g, "")];
                }
            });
        });
    };
    /**
     * Retrieves the SCM domain from the list of enabled domains within the app
     * Note: The SCM domain exposes additional API calls from the standard REST APIs.
     * @param functionApp The function app / web site
     */
    FunctionAppService.prototype.getScmDomain = function (functionApp) {
        return functionApp.enabledHostNames.find(function (hostName) {
            return hostName.includes(".scm.") && hostName.endsWith(".azurewebsites.net");
        });
    };
    return FunctionAppService;
}(baseService_1.BaseService));
exports.FunctionAppService = FunctionAppService;
