"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var bindings_1 = require("./bindings");
var constants_1 = require("./constants");
var Utils = /** @class */ (function () {
    function Utils() {
    }
    Utils.getFunctionMetaData = function (functionName, serverless) {
        var bindings = [];
        var bindingSettingsNames = [];
        var bindingSettings = [];
        var bindingUserSettings = {};
        var bindingType;
        var functionsJson = { disabled: false, bindings: [] };
        var functionObject = serverless.service.getFunction(functionName);
        var handler = functionObject.handler;
        var events = functionObject["events"];
        var params = {
            functionJson: null
        };
        var parsedBindings = bindings_1.BindingUtils.getBindingsMetaData(serverless);
        var bindingTypes = parsedBindings.bindingTypes;
        var bindingDisplayNames = parsedBindings.bindingDisplayNames;
        for (var eventsIndex = 0; eventsIndex < events.length; eventsIndex++) {
            bindingType = Object.keys(functionObject["events"][eventsIndex])[0];
            if (eventsIndex === 0) {
                bindingType += constants_1.constants.trigger;
            }
            var index = bindingTypes.indexOf(bindingType);
            if (index < 0) {
                throw new Error("Binding  " + bindingType + " not supported");
            }
            serverless.cli.log("Building binding for function: " + functionName + " event: " + bindingType);
            bindingUserSettings = {};
            var azureSettings = events[eventsIndex][constants_1.constants.xAzureSettings];
            var bindingTypeIndex = bindingTypes.indexOf(bindingType);
            var bindingUserSettingsMetaData = bindings_1.BindingUtils.getBindingUserSettingsMetaData(azureSettings, bindingType, bindingTypeIndex, bindingDisplayNames);
            bindingTypeIndex = bindingUserSettingsMetaData.index;
            bindingUserSettings = bindingUserSettingsMetaData.userSettings;
            if (bindingType.includes(constants_1.constants.queue) && functionObject["events"][eventsIndex].queue) {
                bindingUserSettings[constants_1.constants.queueName] = functionObject["events"][eventsIndex].queue;
            }
            if (bindingTypeIndex < 0) {
                throw new Error("Binding not supported");
            }
            bindingSettings = parsedBindings.bindingSettings[bindingTypeIndex];
            bindingSettingsNames = parsedBindings.bindingSettingsNames[bindingTypeIndex];
            if (azureSettings) {
                for (var azureSettingKeyIndex = 0; azureSettingKeyIndex < Object.keys(azureSettings).length; azureSettingKeyIndex++) {
                    var key = Object.keys(azureSettings)[azureSettingKeyIndex];
                    if (bindingSettingsNames.indexOf(key) >= 0) {
                        bindingUserSettings[key] = azureSettings[key];
                    }
                }
            }
            bindings.push(bindings_1.BindingUtils.getBinding(bindingType, bindingSettings, bindingUserSettings));
        }
        if (bindingType === constants_1.constants.httpTrigger) {
            bindings.push(bindings_1.BindingUtils.getHttpOutBinding(bindingUserSettings));
        }
        functionsJson.bindings = bindings;
        params.functionsJson = functionsJson;
        var _a = Utils.getEntryPointAndHandlerPath(handler), handlerPath = _a.handlerPath, entryPoint = _a.entryPoint;
        if (functionObject["scriptFile"]) {
            handlerPath = functionObject["scriptFile"];
        }
        return {
            entryPoint: entryPoint,
            handlerPath: path_1.relative(functionName, handlerPath),
            params: params
        };
    };
    Utils.getEntryPointAndHandlerPath = function (handler) {
        var handlerPath = "handler.js";
        var entryPoint = handler;
        var handlerSplit = handler.split(".");
        if (handlerSplit.length > 1) {
            entryPoint = handlerSplit[handlerSplit.length - 1];
            handlerPath = handler.substring(0, handler.lastIndexOf(".")) + ".js";
        }
        var metaData = {
            entryPoint: entryPoint,
            handlerPath: handlerPath
        };
        return metaData;
    };
    Utils.prettyPrint = function (json) {
        return JSON.stringify(json, null, 2);
    };
    Utils.interpolateFile = function (sls, path, params) {
        var template = sls.utils.readFileSync(path);
        var names = params.keys();
        var vals = params.values();
        return new (Function.bind.apply(Function, __spread([void 0], names, ["return `" + template + "`;"])))().apply(void 0, __spread(vals));
    };
    return Utils;
}());
exports.Utils = Utils;
